//AnsiString Class
#ifndef AnsiStringClass
#define AnsiStringClass
#include <windows.h>
#include <string.h>
#include <stdio.h>

#define AnsiStringMAXLEN 256
#define NumberConvertException 10
#define Exception int

static HWND Owner=NULL;

class AnsiString{
  public:
      int ConvertToInt();
      double ConvertToDouble();
      char NumberConvError;
      char String[AnsiStringMAXLEN];
      AnsiString();
	  AnsiString(HWND Hwnd);
      AnsiString(const char* str);
      ~AnsiString();
      AnsiString & operator=(const AnsiString &str);
      AnsiString & operator=(const char * str);
      AnsiString operator+(const AnsiString &str);
      AnsiString operator+(const char * str);
      char& operator[] (unsigned i);
      int AnsiCompare( const AnsiString & str);
      int AnsiCompare( const char * str);
      char* c_str();
      int IsEmpty();
      int Length();
      int Pos(const AnsiString & str);
      int Pos(const char * str);
      int AnsiPos(const AnsiString & str);
      int AnsiPos(const char * str);
      int ToInt();
      double ToDouble();
      AnsiString Delete(int index, int count);
      AnsiString Insert(const AnsiString& str, int index);
      AnsiString Insert(const char * str, int index);
      AnsiString SubString (int index, int count);
      void IntToStr(int x);
      void FloatToStr(double x);
      void Show();
	  void ShowT(char* Title);
	  void ShowT(AnsiString Title);
      void LoadStr(const char* str);
      void LoadStr(const AnsiString &str);
	  void UpperCase();
	  bool Load(AnsiString &fname);
	  bool Save(AnsiString &fname);
	  bool SaveAdd(AnsiString &fname);
	  bool Load(char* fname);
	  bool Save(char* fname);
	  bool SaveAdd(char* fname);
	  void ShowErrorMsg(AnsiString Title);
	  void Sprintf(char*fmt,int n);
	  void Sprintf(char*fmt,float n);
	  void Sprintf(char*fmt,double n);
	  void Sprintf(char*fmt,char* str);
	  void Sprintf(char*fmt,AnsiString& str);
};


static void ShowMessage(AnsiString str){
     str.Show();
}

static void ShowMessage(char* str){
     AnsiString strR(str);
     strR.Show();
}

static void ShowMessageT(char* str,char* Title){
     AnsiString strR(str);
     strR.ShowT(Title);
}

static void ShowMessageT(char* str,AnsiString Title){
     AnsiString strR(str);
     strR.ShowT(Title);
}

static void ShowError(char* msg,char* title){
	AnsiString Title(title);
	AnsiString MSG(msg);
	MSG.ShowErrorMsg(Title);
}

static bool YesNo(char* str){
	if(MessageBox(NULL,str,"Question",MB_YESNO) == IDYES)
		return true;
	else
		return false;
}

static bool YesNo(AnsiString str){
	return YesNo(str.String);
}

static bool OkCancel(char* str){
	if(MessageBox(NULL,str,"Question",MB_OKCANCEL|MB_ICONINFORMATION)==IDOK)
		return true;
	else
		return false;
}

static AnsiString& ExtractFilePath(AnsiString& str){
	AnsiString f=str;
	int x;
	for(x=f.Length()-1;x>=0;x--){
		if((f.String[x]=='\\')||(f.String[x]=='/'))break;
	}
	if(x<0){
		f.String[0]=0;
		return f;
	}
	if(x==f.Length()-1)return f;
	f.String[x+1]=0;
	return f;
}

static AnsiString& ExtractFileName(AnsiString& str){
	int x;
	AnsiString f=str;
	for(x=f.Length()-1;x>=0;x--){
		if((f.String[x]=='\\')||(f.String[x]=='/'))break;
	}
	if(x<0)return f;
	strcpy(f.String,f.String+x+1);
	return f;
}

static AnsiString& ChangeFileExt(AnsiString& str,AnsiString& Ext){
	int x;
	AnsiString f=str;
	for(x=f.Length()-1;x>=0;x--){
		if(f.String[x]=='.')break;
	}
	if(x<0){
		f=f+"."+Ext;
		return f;
	}
	strcpy(f.String+x+1,Ext.String);
	return f;
}

static AnsiString& ChangeFileExt(AnsiString& str,char* Ext){
	AnsiString EXT(Ext);
	return ChangeFileExt(str,EXT);
}

static bool OkCancel(AnsiString str){
	return OkCancel(str.String);
}

static bool FileExists(char* fname){
	FILE*f;
	f=fopen(fname,"r");
	if(f==NULL){
		return false;
	}else{
		fclose(f);
		return true;
	}
}

static bool FileExists(AnsiString fname){
	return FileExists(fname.String);
}

//for random number generation
static int time(int*p){
	SYSTEMTIME time;
	int T;
	GetLocalTime(&time);
	T=time.wYear;
	T+=time.wMonth;
	T+=time.wDay;
	T+=time.wHour;
	T+=time.wMinute;
	T+=time.wSecond;
	return T;
}

#endif
