//Application Class
#include "ApplicationClass.h"

ApplicationClass::ApplicationClass(){
	LPTSTR str=GetCommandLine();
	int cnt;
	WCHAR s[1];
	s[0]=0;
	WCHAR**argv=CommandLineToArgvW(s,&cnt);
	if(!argv){
		ExeName="";
	}else{
		char fn[100];
		sprintf(fn,"%ws",argv[0]);
		ExeName=fn;
	}
}

ApplicationClass::~ApplicationClass(){
}

void ApplicationClass::ProcessMessages(){
     MSG messages;
     DWORD STATE = GetQueueStatus(QS_ALLEVENTS);
     if(HIWORD(STATE)){
         if(GetMessage (&messages, NULL, 0, 0)){
                  TranslateMessage(&messages);
                  DispatchMessage(&messages);
         }
     }
}

void ApplicationClass::Terminate(){
	PostQuitMessage (0);
}

DWORD ApplicationClass::ExecuteCommandLine(char* cmdLine){
   DWORD exitCode=0;
   PROCESS_INFORMATION processInformation = {0};
   STARTUPINFO startupInfo                = {0};
   startupInfo.cb                         = sizeof(startupInfo);

   // Create the process
   BOOL result = CreateProcess(NULL, cmdLine, 
                               NULL, NULL, FALSE, 
                               NORMAL_PRIORITY_CLASS | CREATE_NO_WINDOW, 
                               NULL, NULL, &startupInfo, &processInformation);

   if (!result){
      LPVOID lpMsgBuf;
      DWORD dw = GetLastError();
      FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, 
                    NULL, dw, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR) &lpMsgBuf, 0, NULL);
      char strError[200]; sprintf(strError,"CreateProcess failed:\n%s",(char*) lpMsgBuf);
	  ShowMessage(strError);
      // Free resources created by the system
      LocalFree(lpMsgBuf);
      return exitCode;
   } else {
      // Successfully created the process.  Wait for it to finish.
      WaitForSingleObject( processInformation.hProcess, INFINITE );
      // Get the exit code.
      result = GetExitCodeProcess(processInformation.hProcess, &exitCode);
      // Close the handles.
      CloseHandle( processInformation.hProcess );
      CloseHandle( processInformation.hThread );
      if (!result) {
         // Could not get exit code.
         ShowMessage("Executed command but couldn't get exit code");
         return exitCode;
      }
      // We succeeded.
      return exitCode;
   }
}

DWORD ApplicationClass::ExecuteCommandLine(AnsiString cmdLine){
	return ExecuteCommandLine(cmdLine.c_str());
}
