//Button Class
#ifndef ButtonClassH
#define ButtonClassH

#include <windows.h>
#include "AnsiString.h"
#include "properties.h"

static WNDPROC ButtonProcAddr;

class Button{
    HWND ButtonHwnd;
    AnsiString CaptionText;
    bool EnabledState;
	HFONT hFont;
  public:
    int ID;
    Button(HWND hwnd,HINSTANCE hinst,char* Caption,int* Size);
    ~Button();
      
    property<Button, AnsiString> Caption;
    void SetCaption(const AnsiString & str);
    const AnsiString & GetCaption() const;
    AnsiString & GetRefCaption();
      
    property<Button, bool> Enabled;
    void SetEnabled(const bool & en);
    const bool & GetEnabled() const;
    bool & GetRefEnabled();
	void SetDefFont();
	  
    static LRESULT CALLBACK StatWndProc(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam) {
		switch (Msg){
			case WM_KEYDOWN:	          //Keyboard
				SendMessage(GetParent(hWnd),WM_KEYDOWN,wParam,lParam);
				break;
     
			case WM_CHAR:                 //Keyboard char
				SendMessage(GetParent(hWnd),WM_CHAR,wParam,lParam);
				break;
		}
		return CallWindowProc (ButtonProcAddr,hWnd, Msg, wParam, lParam);
    }
	 
};
#endif
