//MainForm
#include "MainForm.h"


MainForm::MainForm(char * AppName,int StX,int StY){
	Create(AppName,StX,StY);

//user code here	

}

MainForm::~MainForm(){
//user code here

    DestroyForm();
}

//Build up form
void MainForm::BuildForm(HWND hwnd,HINSTANCE hInst){
	Button01=new Button(hwnd,hInst,"START",Button01Param);
	Button02=new Button(hwnd,hInst,"STOP",Button02Param);
	Scroll=new TScrollBar(hwnd,hInst,"",ScrollBar1Param);
	AUDIOOUT=new AudioClass();
	
	Canvas=new CanvasClass(hwnd,20,60,650,512,1);
	
	int x,y;
	for(x=0;x<650;x++){
		Screen[x]=0;
		Screen2[x]=0;
	}
	
	DINP=new unsigned char[BLOCK_SIZE];
	DOUT=new unsigned char[BLOCK_SIZE];
	ZERO=new unsigned char[BLOCK_SIZE/2];
	CONV=new unsigned char[BLOCK_SIZE];
	
	CINP=new unsigned int[BLOCK_SIZE/2];
	COUT=new unsigned int[BLOCK_SIZE/2];
	
	for(x=0;x<BLOCK_SIZE/2;x++){
		CINP[x]=0xFF0000;
		COUT[x]=0x0000FF;
	}
	COUT[BLOCK_SIZE/2-1]=0x00FF00;
	//COUT[BLOCK_SIZE/2-2]=0x00FF00;
	//COUT[BLOCK_SIZE/2-3]=0x00FF00;
	//COUT[BLOCK_SIZE/2-4]=0x00FF00;
	//COUT[BLOCK_SIZE/2-5]=0x00FF00;
	
	//Load file
	FILE*f;
	//f=fopen("E:\\Sajat\\GCC_projects\\WinAudioRecorder\\SND\\SND40","rb");
	f=fopen("E:\\Sajat\\GCC_projects\\WinAudioRecorder\\SND\\SND45","rb");
	//f=fopen("E:\\Sajat\\GCC_projects\\WinAudioRecorder\\SND\\SND23","rb");
	for(x=0;x<BLOCK_SIZE;x++)
		DOUT[x]=DINP[x]=fgetc(f);
	fclose(f);
	
	//digital signal processing stage
	DigitalSignProc();	//Speech shift up
	//DigitalSignProc2();		//Speech shift down
	//DigitalSignProc3();		//AM Vocoding
	
	//draw out
	DrwBase=0;
	DrawOutW();
	
}

//Destroy form
void MainForm::DestroyForm(){
	while(InAudioLoop){
		Sleep(100);
	}
	delete Button01;
	delete Button02;
	delete Scroll;
	delete AUDIOOUT;
	delete[] DINP;
	delete[] DOUT;
	delete[] CINP;
	delete[] COUT;
	delete[] ZERO;
	delete[] CONV;
	delete Canvas;
	int x;
}

void MainForm::OnCommand(WORD command){
	REGCALLBK(Button01) Button1Click();
	REGCALLBK(Button02) Button2Click();
}

//******************************************************************************
//    CALLBACK functions
//******************************************************************************

//Start
void MainForm::Button1Click(){
	AUDIOOUT->writeAudio(DINP, BLOCK_SIZE);
	AUDIOOUT->writeAudio(DINP, BLOCK_SIZE);
	AUDIOOUT->writeAudio(DINP, BLOCK_SIZE);
	AUDIOOUT->writeAudio(DINP, BLOCK_SIZE);
	AUDIOOUT->writeAudio(DINP, BLOCK_SIZE);
	AUDIOOUT->writeAudio(DINP, BLOCK_SIZE);
	AUDIOOUT->writeAudio(DINP, BLOCK_SIZE);
	AUDIOOUT->writeAudio(DINP, BLOCK_SIZE);
}

//Stop
void MainForm::Button2Click(){
	AUDIOOUT->writeAudio(DOUT, BLOCK_SIZE);
	AUDIOOUT->writeAudio(DOUT, BLOCK_SIZE);
	AUDIOOUT->writeAudio(DOUT, BLOCK_SIZE);
	AUDIOOUT->writeAudio(DOUT, BLOCK_SIZE);
	AUDIOOUT->writeAudio(DOUT, BLOCK_SIZE);
	AUDIOOUT->writeAudio(DOUT, BLOCK_SIZE);
	AUDIOOUT->writeAudio(DOUT, BLOCK_SIZE);
	AUDIOOUT->writeAudio(DOUT, BLOCK_SIZE);
}

void MainForm::OnPaint(){
	Canvas->Repaint();
}

void MainForm::OnKeyDown(WPARAM w){
	w=w&0xFF;
	switch(w){
		case VK_LEFT:
			if(DrwBase<=0){
				DrwBase=0;
				return;
			}else
				DrwBase-=50;
			DrawOutW();
			Scroll->SetPos(100*DrwBase/(BLOCK_SIZE-650));
			break;
		case VK_RIGHT:
			if(DrwBase>BLOCK_SIZE-1350){
				DrwBase=BLOCK_SIZE-1350;
				return;
			}else
				DrwBase+=50;
			DrawOutW();
			Scroll->SetPos(100*DrwBase/(BLOCK_SIZE-1300));
			break;
		case VK_UP:
			break;
		case VK_DOWN:
			break;
	}
}

void MainForm::DrawOutW(){
	//draw out
	int x;
	for(x=0;x<650;x++){
		Canvas->Pixels[x][Screen[x]]=0;
		Canvas->Pixels[x][Screen2[x]+256]=0;
	}
	for(x=0;x<650;x++){
		Screen[x]=DINP[x*2+1+DrwBase]+128;
		Canvas->Pixels[x][Screen[x]]=CINP[x+DrwBase/2];
		
		Screen2[x]=DOUT[x*2+1+DrwBase]+128;
		Canvas->Pixels[x][Screen2[x]+256]=COUT[x+DrwBase/2];
	}
	Canvas->Update();
}

//*****************************************************************

void MainForm::DigitalSignProc(){
	//Speech shift up
	//input from DINP output to DOUT	
	int st=-1;
	int pos;
	int dat,datp;
	int cnt=0;
	int z,w;
	int lastzeropos=0;
	for(pos=0;pos<BLOCK_SIZE/2;pos++)
		ZERO[pos]=0;
	pos=0;
	//compressing stage
	for(z=2;z<BLOCK_SIZE;z+=2){
		//serch start of wave: on rising edge
		if(st==-1){
			CINP[z/2]=0x0000FF;
			dat=*((short int*)&DINP[z]);
			datp=*((short int*)&DINP[z-2]);
			if((datp<0)&&(dat>=0)){
				st=z;continue;
			}
			if(z>200)
				st=z;
			continue;
		}
		//count pulses
		dat=*((short int*)&DINP[z]);
		datp=*((short int*)&DINP[z-2]);
		if((datp<0)&&(dat>=0)){
			CINP[z/2]=0xFFFFFF;
			ZERO[pos/2]=1;
			lastzeropos=pos;
		}
		//compress to buffer
		if(cnt<1){
			DOUT[pos++]=DINP[z];
			DOUT[pos++]=DINP[z+1];
			cnt++;
		}else{
			cnt=0;
		}
	}

	DOUT[lastzeropos++]=0;
	DOUT[lastzeropos++]=0;
	
	//double all output pulses
	pos=0;
	st=0;
	for(z=0;z<lastzeropos;z+=2){
		CONV[pos++]=DOUT[z];
		CONV[pos++]=DOUT[z+1];
		if(ZERO[z/2]){
			for(w=st;w<z;w++)
				CONV[pos++]=DOUT[w];
			st=w;
		}
	}
	
	//final alignment
	int needed=(BLOCK_SIZE-pos)/2;
	//int done=0;
	int space=BLOCK_SIZE/2/needed;
	pos=0;
	cnt=0;
	for(z=0;z<BLOCK_SIZE;z+=2){
		DOUT[pos++]=CONV[z];
		DOUT[pos++]=CONV[z+1];
		if(pos>=BLOCK_SIZE)break;
		if(cnt>=space){
			cnt=0;
			DOUT[pos++]=CONV[z];
			DOUT[pos++]=CONV[z+1];
			//done++;
			if(pos>=BLOCK_SIZE)break;
		}else
			cnt++;
	}

	DOUT[BLOCK_SIZE-1]=0;
	DOUT[BLOCK_SIZE-2]=0;
}

//*****************************************************************

void MainForm::DigitalSignProc2(){
	//Speech shift down
	//input from DINP output to DOUT	
	int st=-1;
	int pos;
	int dat,datp;
	int z,w;
	unsigned char skipping=0;
	int lastzeropos;
	int cnt=0;
	pos=0;
	
	//Stage1: skip all second pulses
	for(z=2;z<BLOCK_SIZE;z+=2){
		//serch start of wave: on rising edge
		if(st==-1){
			CINP[z/2]=0x0000FF;
			dat=*((short int*)&DINP[z]);
			datp=*((short int*)&DINP[z-2]);
			if((datp<0)&&(dat>=0)){
				st=z;continue;
			}
			if(z>200)
				st=z;
			continue;
		}
		//copy
		if(!skipping){
			DOUT[pos++]=DINP[z];
			DOUT[pos++]=DINP[z+1];
		}
		//search rising edge
		cnt++;
		dat=*((short int*)&DINP[z]);
		datp=*((short int*)&DINP[z-2]);
		if(((datp<0)&&(dat>=0))||(cnt>=441)){
			cnt=0;
			CINP[z/2]=0xFFFFFF;
			skipping=!skipping;
			lastzeropos=pos;
		}
	}
	
	DOUT[lastzeropos++]=0;
	DOUT[lastzeropos++]=0;
	
	//Stage2: double all sample
	pos=0;
	CONV[pos++]=DOUT[0];
	CONV[pos++]=DOUT[1];
	for(z=2;z<lastzeropos;z+=2){
		dat=*((short int*)&DOUT[z]);
		datp=*((short int*)&DOUT[z-2]);
		dat=(dat+datp)/2;
		*((short int*)&CONV[pos])=dat;
		pos+=2;
		if(pos>=BLOCK_SIZE)break;
		CONV[pos++]=DOUT[z];
		CONV[pos++]=DOUT[z+1];
		if(pos>=BLOCK_SIZE)break;
		if(BLOCK_SIZE-pos<=lastzeropos-z+2){
			z+=2;
			for(;pos<BLOCK_SIZE;pos++)
				CONV[pos]=DOUT[z++];
			break;
		}
	}
	
	//Stage3: final alignment
	int needed=(BLOCK_SIZE-pos)/2;
	int done=0;
	int space;
	cnt=1;
	if(needed>0){
		space=BLOCK_SIZE/2/needed;
		pos=0;
		for(z=0;z<BLOCK_SIZE;z+=2){
			DOUT[pos++]=CONV[z];
			DOUT[pos++]=CONV[z+1];
			if(pos>=BLOCK_SIZE)break;
			if(cnt>=space){
				cnt=1;
				DOUT[pos++]=CONV[z];
				DOUT[pos++]=CONV[z+1];
				done++;
				if(done>=needed)break;
				if(pos>=BLOCK_SIZE)break;
			}else
				cnt++;
		}
		for(;pos<BLOCK_SIZE;pos++){
			DOUT[pos]=CONV[z++];
		}
	}else{
		memcpy(DOUT,CONV,BLOCK_SIZE);
	}

	//done=done;
}

//*****************************************************************

//#define SAVEPULSE

void MainForm::DigitalSignProc3(){
	//AM Vocoder
	//input from DINP output to DOUT	
	
//TEST: SAVE TO FILE ONE SELECTED PULSE*******************
#ifdef SAVEPULSE
	int st=0;
	int pos;
	int dat,datp;
	int z,w;
	unsigned char skipping=0;
	int lastzeropos;
	int cnt=0;
	pos=0;
	FILE*f;
	f=fopen("Pulse.txt","wt");
	
	//Stage1: skip all second pulses
	for(z=2;z<BLOCK_SIZE;z+=2){
		//serch start of wave: on rising edge
		if(st<15){
			CINP[z/2]=0x0000FF;
			dat=*((short int*)&DINP[z]);
			datp=*((short int*)&DINP[z-2]);
			if((datp<0)&&(dat>=0)){
				st++;
			}
			continue;
		}
		//copy

		CINP[z/2]=0x00FFFF;
		DOUT[pos++]=DINP[z];
		DOUT[pos++]=DINP[z+1];
		dat=*((short int*)&DOUT[z]);
		fprintf(f,"%d,\n",dat);
			
		//search rising edge
		cnt++;
		dat=*((short int*)&DINP[z]);
		datp=*((short int*)&DINP[z-2]);
		if(((datp<0)&&(dat>=0))||(cnt>=441)){
			cnt=0;
			CINP[z/2]=0xFFFFFF;
			lastzeropos=pos;
			skipping++;
			if(skipping>6)
				break;
		}
	}
	
	fclose(f);
	return;
#else



//***** real DSP code ***** 


	//Create coverer wave
	int z;
	int dat,datp,datn;
	DOUT[0]=0;
	DOUT[1]=0;
	DOUT[BLOCK_SIZE-1]=0;
	DOUT[BLOCK_SIZE-2]=0;
	for(z=2;z<BLOCK_SIZE-2;z+=2){
		dat=*((short int*)&DINP[z]);
		datp=*((short int*)&DINP[z-2]);
		datn=*((short int*)&DINP[z+2]);
		if((dat>0)&&(dat>datn)&&(dat>datp)){
			DOUT[z]=DINP[z];
			DOUT[z+1]=DINP[z+1];
		}else{
			DOUT[z]=0;
			DOUT[z+1]=0;
		}
	}
	
	int lastpul=0;
	float b,m;
	int w;
	for(z=0;z<BLOCK_SIZE;z+=2){
		if(DOUT[z]){
			datp=*((short int*)&DOUT[z]);
			datn=*((short int*)&DOUT[lastpul]);
			Line(z,datp,lastpul,datn,DOUT);
			lastpul=z;
		}
	}
	
//wave1
	int count=0;
	float perc;
	for(z=0;z<BLOCK_SIZE;z+=2){
		perc=(float)(*((short int*)&DOUT[z])/20000.0);
		*((short int*)&DOUT[z])=(int)(perc*(float)wave1[count]);
		count++;
		if(count>418)count=0;
	}
	
	
#endif
}

void MainForm::Line(int x1, int y1, int x2, int y2, unsigned char* DAT){
	int dx, dy, inx, iny, e;
	
	dx = x2 - x1;
	dy = y2 - y1;
	inx = dx > 0 ? 1 : -1;
	iny = dy > 0 ? 1 : -1;

	dx = (dx>=0)?dx:-dx;
	dy = (dy>=0)?dy:-dy;
	
	if(dx >= dy) {
		dy <<= 1;
		e = dy - dx;
		dx <<= 1;
		while (x1 != x2) {
			//setpixel(x1, y1, color);
			*((short int*)&DAT[x1])=y1;
			if(e >= 0) {
				y1 += iny;
				e-= dx;
			}
			e += dy; x1 += inx;
		}
	} else {
		dx <<= 1;
		e = dx - dy;
		dy <<= 1;
		while (y1 != y2) {
			//setpixel(x1, y1, color);
			*((short int*)&DAT[x1])=y1;
			if(e >= 0) {
				x1 += inx;
				e -= dy;
			}
			e += dx; y1 += iny;
		}
	}
	//setpixel(x1, y1, color);
	*((short int*)&DAT[x1])=y1;
}
