//MainForm
#ifndef MainFormH
#define MainFormH

#include "..\FormClass.h"
#include "..\AnsiString.h"
#include "..\hinstance.h"
#include "..\AudioClass.h"
#include "..\ButtonClass.h"
#include "..\CanvasClass.h"
#include "..\TScrollBar.h"

#include "MainFormParams.h"

static volatile int crec=0;
static volatile int InAudioLoop=0;

class MainForm : FormClass{
public:
	MainForm(char * AppName,int StX,int StY);
	~MainForm();
	void BuildForm(HWND hwnd,HINSTANCE hInst);
	void DestroyForm();
	void OnPaint();
	void OnCommand(WORD command);
	
	Button*  Button01;
	Button*  Button02;
	TScrollBar* Scroll;
	
	CanvasClass* Canvas;
	
	void Button1Click();
	void Button2Click();
	void OnKeyDown(WPARAM w);

private:	// User declarations
	AudioClass* AUDIOOUT;
	
	//input output data buffers
	unsigned char* DOUT;
	unsigned char* DINP;
	unsigned char* CONV;
	unsigned char* ZERO;
	
	//data colour info
	unsigned int* COUT;
	unsigned int* CINP;
	
	//Screen old-data buffers
	unsigned char Screen[650];
	unsigned char Screen2[650];
	
	//for shift-draw
	int DrwBase;
	void DrawOutW();
	
	//digital signal processing
	void DigitalSignProc();		//Speech shift up
	void DigitalSignProc2();	//Speech shift down
	void DigitalSignProc3();	//AM Vocoder
	void Line(int x1, int y1, int x2, int y2, unsigned char* DAT);

};

#endif
