//Label Class
#ifndef LabelClassH
#define LabelClassH

#include <windows.h>
#include "AnsiString.h"
#include "properties.h"

static WNDPROC LabelProcAddr;

class Label{
    HWND LabelHwnd;
    AnsiString CaptionText;
	HFONT hFont;
  public:
    int ID;
    Label(HWND hwnd,HINSTANCE hinst,char* Caption,int* Size);
    ~Label();
    property<Label, AnsiString> Caption;
    void SetCaption(const AnsiString & str);
    const AnsiString & GetCaption() const;
    AnsiString & GetRefCaption();
	void SetDefFont();
	  
    static LRESULT CALLBACK StatWndProc(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam) {
		switch (Msg){
			case WM_KEYDOWN:	          //Keyboard
				SendMessage(GetParent(hWnd),WM_KEYDOWN,wParam,lParam);
				break;
     
			case WM_CHAR:                 //Keyboard char
				SendMessage(GetParent(hWnd),WM_CHAR,wParam,lParam);
				break;
				
			case WM_GETDLGCODE:
				if(wParam==VK_RETURN)
					SendMessage(GetParent(hWnd),WM_KEYDOWN,13,0);
				if(wParam==VK_TAB)
					SendMessage(GetParent(hWnd),WM_KEYDOWN,VK_TAB,0);
				if(wParam==VK_ESCAPE)
					SendMessage(GetParent(hWnd),WM_KEYDOWN,VK_ESCAPE,0);
				break;
		}
		return CallWindowProc (LabelProcAddr,hWnd, Msg, wParam, lParam);
    }
	  
};

#endif
