//MainForm
#include "MainForm.h"


MainForm::MainForm(){
	CreateSpecial("Voice Distorter - Andras Bognar 2012",20,20,880,580,1);

//user code here	

}

MainForm::~MainForm(){
//user code here

    DestroyForm();
}

//Build up form
void MainForm::BuildForm(HWND hwnd,HINSTANCE hInst){
	Button01=new Button(hwnd,hInst,"START RECORDING",Button01Param);
	Button02=new Button(hwnd,hInst,"STOP  RECORDING",Button02Param);
	
	Check1=new TCheckBox(hwnd,hInst,"AM modulation ON/OFF",Check01Param);
	Radio1=new TRadioButton(hwnd,hInst,"Modulation1",Radio01Param);
	Radio2=new TRadioButton(hwnd,hInst,"Modulation2",Radio02Param);
	Radio3=new TRadioButton(hwnd,hInst,"Modulation3",Radio03Param);
	Radio4=new TRadioButton(hwnd,hInst,"Modulation4",Radio04Param);
	Radio1->Checked=true;
	
	Check2=new TCheckBox(hwnd,hInst,"Pitch Shifter ON/OFF",Check02Param);
	Radio5=new TRadioButton(hwnd,hInst,"Pitch DOWN",Radio05Param);
	Radio6=new TRadioButton(hwnd,hInst,"Pitch UP",Radio06Param);
	Radio5->Checked=true;
	
	Check3=new TCheckBox(hwnd,hInst,"Echo ON/OFF",Check03Param);
	Radio7=new TRadioButton(hwnd,hInst,"Echo 1",Radio07Param);
	Radio8=new TRadioButton(hwnd,hInst,"Echo 2",Radio08Param);
	Radio9=new TRadioButton(hwnd,hInst,"Echo 3",Radio09Param);
	Radi10=new TRadioButton(hwnd,hInst,"Echo 4",Radio10Param);
	Radio7->Checked=true;
	
	Label1=new Label(hwnd,hInst,"Save output to .WAV file",Label1Param);
	
	Canvas=new CanvasClass(hwnd,20,20,650,512,1);
	
	recordingRUN=0;
	AMmodOn=0;
	PitchOn=0;
	EchoOn=0;
	AMmod=1;
	PitchMod=1;
	EchoMod=1;
	
	REC=new AudioRecorder(hwnd);
	AUDIOOUT=new AudioClass();
	
	//Screen init
	int x,y;
	for(x=0;x<650;x++){
		Screen[x]=0;
		Screen2[x]=0;
	}
	
	//Echo data blocks
	Pecho=0;
	echo=new unsigned char[BLOCK_SIZE*16];
	if(!echo){
		ShowError("ERROR: Memory allocation error!","NEW: NULL");
		Application->Terminate();
	}
	
	//Converter data buffers
	DINP=new unsigned char[BLOCK_SIZE];
	DOUT=new unsigned char[BLOCK_SIZE];
	CONV=new unsigned char[BLOCK_SIZE];
	ZERO=new unsigned char[BLOCK_SIZE/2];
	DPLAY=new unsigned char[BLOCK_SIZE];
	
	if(!DINP){
		ShowError("ERROR: Memory allocation error!","NEW: NULL");
		Application->Terminate();
	}
	if(!DOUT){
		ShowError("ERROR: Memory allocation error!","NEW: NULL");
		Application->Terminate();
	}
	if(!CONV){
		ShowError("ERROR: Memory allocation error!","NEW: NULL");
		Application->Terminate();
	}
	if(!ZERO){
		ShowError("ERROR: Memory allocation error!","NEW: NULL");
		Application->Terminate();
	}
	if(!DPLAY){
		ShowError("ERROR: Memory allocation error!","NEW: NULL");
		Application->Terminate();
	}
	
	//Start data processing
	REC->StartRec();
}

//Destroy form
void MainForm::DestroyForm(){
	while(InAudioLoop){
		Sleep(100);
	}
	delete Button01;
	delete Button02;
	delete Check1;
	delete Radio1;
	delete Radio2;
	delete Radio3;
	delete Radio4;
	delete Check2;
	delete Radio5;
	delete Radio6;
	delete Check3;
	delete Radio7;
	delete Radio8;
	delete Radio9;
	delete Radi10;
	
	delete REC;
	delete AUDIOOUT;
	delete Canvas;
	
	delete[] DINP;
	delete[] DOUT;
	delete[] CONV;
	delete[] ZERO;
	delete[] DPLAY;
	
	delete[] echo;
}

void MainForm::OnCommand(WORD command){
	REGCALLBK(Button01) Button1Click();
	REGCALLBK(Button02) Button2Click();
	
	REGCALLBK(Check1) Check1Click();
	REGCALLBK(Check2) Check2Click();
	REGCALLBK(Check3) Check3Click();
	
	REGCALLBK(Radio1) Radio1Click();
	REGCALLBK(Radio2) Radio2Click();
	REGCALLBK(Radio3) Radio3Click();
	REGCALLBK(Radio4) Radio4Click();
	REGCALLBK(Radio5) Radio5Click();
	REGCALLBK(Radio6) Radio6Click();
	REGCALLBK(Radio7) Radio7Click();
	REGCALLBK(Radio8) Radio8Click();
	REGCALLBK(Radio9) Radio9Click();
	REGCALLBK(Radi10) Radio10Click();
}

//******************************************************************************
//    CALLBACK functions
//******************************************************************************
void MainForm::OnAudioRecData(){
	int z;
	if(InAudioLoop)
		return;
	InAudioLoop=1;
	DINPorig=REC->GetRecData();
	memcpy(DINP,DINPorig,BLOCK_SIZE);
	memcpy(DOUT,DINP,BLOCK_SIZE);
	
	//*************************************************************
	/*TEST CODE
#ifdef RECORDTOFILE
	static int filecnt=0;
	FILE*f;
	char fname[20];
	sprintf(fname,"SND%d",filecnt++);
	f=fopen(fname,"wb");
	for(int m=0;m<BLOCK_SIZE;m++)
		fputc(DAT[m],f);
	fclose(f);
#endif
	*/
	
	//*************************************************************
	//Pitch Shifter
	if(AMmodOn){
		if(AMmod==1){
			WLEN=W1LEN;
			waveD=wave1;
			DSP_AmMod();
		}
		
		if(AMmod==2){
			WLEN=W2LEN;
			waveD=wave2;
			DSP_AmMod();
		}
		
		if(AMmod==3){
			WLEN=W3LEN;
			waveD=wave3;
			DSP_AmMod();
		}
		
		if(AMmod==4){
			WLEN=W4LEN;
			waveD=wave4;
			DSP_AmMod();
		}
		
		if(PitchOn||EchoOn)
			memcpy(DINP,DOUT,BLOCK_SIZE);
	}
	
	//*************************************************************
	//Pitch Shifter
	if(PitchOn){
		if(PitchMod==1){
			DSP_PitchDown();
		}
		
		if(PitchMod==2){
			DSP_PitchUP();
		}
		
		if(EchoOn)
			memcpy(DINP,DOUT,BLOCK_SIZE);
	}
	
	//*************************************************************
	//echo generator
	if(EchoOn){
		//copy to echo generator
		long int actpos=Pecho*BLOCK_SIZE;
		memcpy(&echo[actpos],DINP,BLOCK_SIZE);
		Pecho++;
		Pecho&=0xF;
		//echo generator
		short int d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s;
		float Fd,Fe,Ff,Fg,Fh,Fi,Fj,Fk,Fl,Fm,Fn,Fo,Fp,Fq,Fr,Fs;
		
		if(EchoMod==1){
			for(long int z=0;z<BLOCK_SIZE;z+=2){
				//magnetic echo heads
				d=*((short int*)&echo[(z+actpos)&0x1FFFF]);
				e=*((short int*)&echo[(z+actpos-BLOCK_SIZE)&0x1FFFF]);
				f=*((short int*)&echo[(z+actpos-BLOCK_SIZE*2)&0x1FFFF]);
				g=*((short int*)&echo[(z+actpos-BLOCK_SIZE*3)&0x1FFFF]);
				h=*((short int*)&echo[(z+actpos-BLOCK_SIZE*4)&0x1FFFF]);
				i=*((short int*)&echo[(z+actpos-BLOCK_SIZE*5)&0x1FFFF]);
				j=*((short int*)&echo[(z+actpos-BLOCK_SIZE*6)&0x1FFFF]);
				k=*((short int*)&echo[(z+actpos-BLOCK_SIZE*7)&0x1FFFF]);
				l=*((short int*)&echo[(z+actpos-BLOCK_SIZE*8)&0x1FFFF]);
				m=*((short int*)&echo[(z+actpos-BLOCK_SIZE*9)&0x1FFFF]);
				n=*((short int*)&echo[(z+actpos-BLOCK_SIZE*10)&0x1FFFF]);
				o=*((short int*)&echo[(z+actpos-BLOCK_SIZE*11)&0x1FFFF]);
				p=*((short int*)&echo[(z+actpos-BLOCK_SIZE*12)&0x1FFFF]);
				q=*((short int*)&echo[(z+actpos-BLOCK_SIZE*13)&0x1FFFF]);
				r=*((short int*)&echo[(z+actpos-BLOCK_SIZE*14)&0x1FFFF]);
				s=*((short int*)&echo[(z+actpos-BLOCK_SIZE*15)&0x1FFFF]);
				Fd=(float)d;
				Fe=(float)e;
				Ff=(float)f;
				Fg=(float)g;
				Fh=(float)h;
				Fi=(float)i;
				Fj=(float)j;
				Fk=(float)k;
				Fl=(float)l;
				Fm=(float)m;
				Fn=(float)n;
				Fo=(float)o;
				Fp=(float)p;
				Fq=(float)q;
				Fr=(float)r;
				Fs=(float)s;
				//Mix the echo heads
				*((short int*)&DOUT[z])=(short int)(	
												Fd*0.3+
												Fe*0.2+
												Ff*0.1+
												Fg*0.1+
												Fh*0.1+
												Fi*0.1+
												Fj*0.1+
												Fk*0.1+
												Fl*0.1+
												Fm*0.05+
												Fn*0.051+
												Fo*0.031+
												Fp*0.021+
												Fq*0.011+
												Fr*0.001+
												Fs*0.001
				);
			}
		}
		
		if(EchoMod==2){
			for(long int z=0;z<BLOCK_SIZE;z+=2){
				//magnetic echo heads
				d=*((short int*)&echo[(z+actpos)&0x1FFFF]);
				e=*((short int*)&echo[(z+actpos-1000)&0x1FFFF]);
				f=*((short int*)&echo[(z+actpos-1000*2)&0x1FFFF]);
				g=*((short int*)&echo[(z+actpos-1000*3)&0x1FFFF]);
				h=*((short int*)&echo[(z+actpos-1000*4)&0x1FFFF]);
				i=*((short int*)&echo[(z+actpos-1000*5)&0x1FFFF]);
				j=*((short int*)&echo[(z+actpos-1000*6)&0x1FFFF]);
				k=*((short int*)&echo[(z+actpos-1000*7)&0x1FFFF]);
				l=*((short int*)&echo[(z+actpos-1000*8)&0x1FFFF]);
				m=*((short int*)&echo[(z+actpos-1000*9)&0x1FFFF]);
				n=*((short int*)&echo[(z+actpos-1000*10)&0x1FFFF]);
				o=*((short int*)&echo[(z+actpos-1000*11)&0x1FFFF]);
				p=*((short int*)&echo[(z+actpos-1000*12)&0x1FFFF]);
				q=*((short int*)&echo[(z+actpos-1000*13)&0x1FFFF]);
				r=*((short int*)&echo[(z+actpos-1000*14)&0x1FFFF]);
				s=*((short int*)&echo[(z+actpos-1000*15)&0x1FFFF]);
				Fd=(float)d;
				Fe=(float)e;
				Ff=(float)f;
				Fg=(float)g;
				Fh=(float)h;
				Fi=(float)i;
				Fj=(float)j;
				Fk=(float)k;
				Fl=(float)l;
				Fm=(float)m;
				Fn=(float)n;
				Fo=(float)o;
				Fp=(float)p;
				Fq=(float)q;
				Fr=(float)r;
				Fs=(float)s;
				//Mix the echo heads
				*((short int*)&DOUT[z])=(short int)(	
												Fd*0.3+
												Fe*0.2+
												Ff*0.1+
												Fg*0.1+
												Fh*0.1+
												Fi*0.1+
												Fj*0.1+
												Fk*0.1+
												Fl*0.1+
												Fm*0.05+
												Fn*0.051+
												Fo*0.031+
												Fp*0.021+
												Fq*0.011+
												Fr*0.001+
												Fs*0.001
				);
			}
		}
		
		if(EchoMod==3){
			for(long int z=0;z<BLOCK_SIZE;z+=2){
				//magnetic echo heads
				d=*((short int*)&echo[(z+actpos)&0x1FFFF]);
				e=*((short int*)&echo[(z+actpos-BLOCK_SIZE)&0x1FFFF]);
				f=*((short int*)&echo[(z+actpos-BLOCK_SIZE*2)&0x1FFFF]);
				g=*((short int*)&echo[(z+actpos-BLOCK_SIZE*3)&0x1FFFF]);
				h=*((short int*)&echo[(z+actpos-BLOCK_SIZE*4)&0x1FFFF]);
				i=*((short int*)&echo[(z+actpos-BLOCK_SIZE*5)&0x1FFFF]);
				j=*((short int*)&echo[(z+actpos-BLOCK_SIZE*6)&0x1FFFF]);
				k=*((short int*)&echo[(z+actpos-BLOCK_SIZE*7)&0x1FFFF]);
				l=*((short int*)&echo[(z+actpos-BLOCK_SIZE*8)&0x1FFFF]);
				m=*((short int*)&echo[(z+actpos-BLOCK_SIZE*9)&0x1FFFF]);
				n=*((short int*)&echo[(z+actpos-BLOCK_SIZE*10)&0x1FFFF]);
				o=*((short int*)&echo[(z+actpos-BLOCK_SIZE*11)&0x1FFFF]);
				p=*((short int*)&echo[(z+actpos-BLOCK_SIZE*12)&0x1FFFF]);
				q=*((short int*)&echo[(z+actpos-BLOCK_SIZE*13)&0x1FFFF]);
				r=*((short int*)&echo[(z+actpos-BLOCK_SIZE*14)&0x1FFFF]);
				s=*((short int*)&echo[(z+actpos-BLOCK_SIZE*15)&0x1FFFF]);
				Fd=(float)d;
				Fe=(float)e;
				Ff=(float)f;
				Fg=(float)g;
				Fh=(float)h;
				Fi=(float)i;
				Fj=(float)j;
				Fk=(float)k;
				Fl=(float)l;
				Fm=(float)m;
				Fn=(float)n;
				Fo=(float)o;
				Fp=(float)p;
				Fq=(float)q;
				Fr=(float)r;
				Fs=(float)s;
				//Mix the echo heads
				*((short int*)&DOUT[z])=(short int)(	
												Fd*0.003+
												Fe*0.002+
												Ff*0.001+
												Fg*0.01+
												Fh*0.1+
												Fi*0.001+
												Fj*0.1+
												Fk*0.1+
												Fl*0.1+
												Fm*0.2+
												Fn*0.1+
												Fo*0.1+
												Fp*0.1+
												Fq*0.2+
												Fr*0.2+
												Fs*0.1
				);
			}
		}
		
		if(EchoMod==4){
			for(long int z=0;z<BLOCK_SIZE;z+=2){
				//magnetic echo heads
				d=*((short int*)&echo[(z+actpos)&0x1FFFF]);
				e=*((short int*)&echo[(z+actpos-4000)&0x1FFFF]);
				f=*((short int*)&echo[(z+actpos-4000*2)&0x1FFFF]);
				g=*((short int*)&echo[(z+actpos-4000*3)&0x1FFFF]);
				h=*((short int*)&echo[(z+actpos-4000*4)&0x1FFFF]);
				i=*((short int*)&echo[(z+actpos-4000*5)&0x1FFFF]);
				j=*((short int*)&echo[(z+actpos-4000*6)&0x1FFFF]);
				k=*((short int*)&echo[(z+actpos-4000*7)&0x1FFFF]);
				l=*((short int*)&echo[(z+actpos-4000*8)&0x1FFFF]);
				m=*((short int*)&echo[(z+actpos-4000*9)&0x1FFFF]);
				n=*((short int*)&echo[(z+actpos-4000*10)&0x1FFFF]);
				o=*((short int*)&echo[(z+actpos-4000*11)&0x1FFFF]);
				p=*((short int*)&echo[(z+actpos-4000*12)&0x1FFFF]);
				q=*((short int*)&echo[(z+actpos-4000*13)&0x1FFFF]);
				r=*((short int*)&echo[(z+actpos-4000*14)&0x1FFFF]);
				s=*((short int*)&echo[(z+actpos-4000*15)&0x1FFFF]);
				Fd=(float)d;
				Fe=(float)e;
				Ff=(float)f;
				Fg=(float)g;
				Fh=(float)h;
				Fi=(float)i;
				Fj=(float)j;
				Fk=(float)k;
				Fl=(float)l;
				Fm=(float)m;
				Fn=(float)n;
				Fo=(float)o;
				Fp=(float)p;
				Fq=(float)q;
				Fr=(float)r;
				Fs=(float)s;
				//Mix the echo heads
				*((short int*)&DOUT[z])=(short int)(	
												Fd*0.3+
												Fe*0.2+
												Ff*0.1+
												Fg*0.1+
												Fh*0.1+
												Fi*0.1+
												Fj*0.1+
												Fk*0.1+
												Fl*0.1+
												Fm*0.05+
												Fn*0.051+
												Fo*0.031+
												Fp*0.021+
												Fq*0.011+
												Fr*0.001+
												Fs*0.001
				);
			}
		}
		
	}
	
	//*************************************************************
	//Writing to file if recording ON
	if(recordingRUN){
		for(z=0;z<BLOCK_SIZE;z++)
			fputc(DOUT[z],fwave);
		BlocksSaved++;
		if(crec>500){
			ShowMessage("Recording File size reached maximum.");
			Button2Click();
			//InAudioLoop=0;
			//return;
		}
	}
	
	//*************************************************************
	//Play the results
	int poi=0;
	for(z=0;z<BLOCK_SIZE_REC/2;z+=2){
		DPLAY[poi]=DOUT[z];
		DPLAY[poi+2]=DOUT[z];
		DPLAY[poi+1]=DOUT[z+1];
		DPLAY[poi+3]=DOUT[z+1];
		poi+=4;
	}
	AUDIOOUT->writeAudio(DPLAY, BLOCK_SIZE_REC);
	poi=0;
	for(z=BLOCK_SIZE_REC/2;z<BLOCK_SIZE_REC;z+=2){
		DPLAY[poi]=DOUT[z];
		DPLAY[poi+2]=DOUT[z];
		DPLAY[poi+1]=DOUT[z+1];
		DPLAY[poi+3]=DOUT[z+1];
		poi+=4;
	}
	AUDIOOUT->writeAudio(DPLAY, BLOCK_SIZE_REC);
	
	crec++;
	
	//*************************************************************
	//Drawing Wave
	int x;
	if((crec&0x1)==1){
		for(x=0;x<650;x++){
			Canvas->Pixels[x][Screen[x]]=0;
			Canvas->Pixels[x][Screen2[x]+256]=0;
		}
		for(x=0;x<650;x++){
			Screen[x]=DINPorig[x*2+1]+128;
			Canvas->Pixels[x][Screen[x]]=0xFFFFFF;
			
			Screen2[x]=DOUT[x*2+1]+128;
			Canvas->Pixels[x][Screen2[x]+256]=0x00FF00;
		}
		Canvas->Update();
	}
	
	InAudioLoop=0;
}

//Start recording
void MainForm::Button1Click(){
	if(recordingRUN)
		return;
	recordingRUN=1;
	Button01->Enabled=false;
	fwave=fopen("sample.wav","wb");
	int x;
	crec=0;
	BlocksSaved=0;
	for(x=0;x<44;x++)
		fputc(wavedata[x],fwave);
}

//Stop recording
void MainForm::Button2Click(){
	if(!recordingRUN)
		return;
	recordingRUN=0;
	
	long int len=(long int)BlocksSaved*BLOCK_SIZE;
	fseek ( fwave , 40 , SEEK_SET );
	fputc(len&0xFF,fwave);
	fputc((len>>8)&0xFF,fwave);
	fputc((len>>16)&0xFF,fwave);
	fputc((len>>24)&0xFF,fwave);
	
	len+=36;
	fseek ( fwave , 4 , SEEK_SET );
	fputc(len&0xFF,fwave);
	fputc((len>>8)&0xFF,fwave);
	fputc((len>>16)&0xFF,fwave);
	fputc((len>>24)&0xFF,fwave);

	ShowMessage("OUTPUT Recorded to sample.wav");
	
	Button01->Enabled=true;
	fclose(fwave);
}

void MainForm::Check1Click(){
	if(Check1->Checked){
		Check1->Checked=false;
		AMmodOn=0;
	}else{
		Check1->Checked=true;
		AMmodOn=1;
	}
}

void MainForm::Check2Click(){
	if(Check2->Checked){
		Check2->Checked=false;
		PitchOn=0;
	}else{
		Check2->Checked=true;
		PitchOn=1;
	}
}

void MainForm::Check3Click(){
	if(Check3->Checked){
		Check3->Checked=false;
		EchoOn=0;
	}else{
		Check3->Checked=true;
		EchoOn=1;
	}
}

void MainForm::Radio1Click(){
	if(!Check1->Checked){
		Check1->Checked=true;
		AMmodOn=1;
	}
	Radio1->Checked=true;
	Radio2->Checked=false;
	Radio3->Checked=false;
	Radio4->Checked=false;
	AMmod=1;
}

void MainForm::Radio2Click(){
	if(!Check1->Checked){
		Check1->Checked=true;
		AMmodOn=1;
	}
	if(!Check2->Checked)
	Radio1->Checked=false;
	Radio2->Checked=true;
	Radio3->Checked=false;
	Radio4->Checked=false;
	AMmod=2;
}

void MainForm::Radio3Click(){
	if(!Check1->Checked){
		Check1->Checked=true;
		AMmodOn=1;
	}
	Radio1->Checked=false;
	Radio2->Checked=false;
	Radio3->Checked=true;
	Radio4->Checked=false;
	AMmod=3;
}

void MainForm::Radio4Click(){
	if(!Check1->Checked){
		Check1->Checked=true;
		AMmodOn=1;
	}
	Radio1->Checked=false;
	Radio2->Checked=false;
	Radio3->Checked=false;
	Radio4->Checked=true;
	AMmod=4;
}

void MainForm::Radio5Click(){
	if(!Check2->Checked){
		Check2->Checked=true;
		PitchOn=1;
	}
	Radio5->Checked=true;
	Radio6->Checked=false;
	PitchMod=1;
}

void MainForm::Radio6Click(){
	if(!Check2->Checked){
		Check2->Checked=true;
		PitchOn=1;
	}
	Radio5->Checked=false;
	Radio6->Checked=true;
	PitchMod=2;
}

void MainForm::Radio7Click(){
	if(!Check3->Checked){
		Check3->Checked=true;
		EchoOn=1;
	}
	Radio7->Checked=true;
	Radio8->Checked=false;
	Radio9->Checked=false;
	Radi10->Checked=false;
	EchoMod=1;
}

void MainForm::Radio8Click(){
	if(!Check3->Checked){
		Check3->Checked=true;
		EchoOn=1;
	}
	Radio7->Checked=false;
	Radio8->Checked=true;
	Radio9->Checked=false;
	Radi10->Checked=false;
	EchoMod=2;
}

void MainForm::Radio9Click(){
	if(!Check3->Checked){
		Check3->Checked=true;
		EchoOn=1;
	}
	Radio7->Checked=false;
	Radio8->Checked=false;
	Radio9->Checked=true;
	Radi10->Checked=false;
	EchoMod=3;
}

void MainForm::Radio10Click(){
	if(!Check3->Checked){
		Check3->Checked=true;
		EchoOn=1;
	}
	Radio7->Checked=false;
	Radio8->Checked=false;
	Radio9->Checked=false;
	Radi10->Checked=true;
	EchoMod=4;
}


void MainForm::OnPaint(){
	Canvas->Repaint();
}

//SIGNAL PROCESSOR FUNCTIONS
//*****************************************************************

void MainForm::DSP_PitchUP(){
	//Speech shift up
	//input from DINP output to DOUT	
	int st=-1;
	int pos;
	int dat,datp;
	int cnt=0;
	int z,w;
	int lastzeropos=0;
	for(pos=0;pos<BLOCK_SIZE/2;pos++)
		ZERO[pos]=0;
	pos=0;
	//compressing stage
	for(z=2;z<BLOCK_SIZE;z+=2){
		//serch start of wave: on rising edge
		if(st==-1){
			//CINP[z/2]=0x0000FF;
			dat=*((short int*)&DINP[z]);
			datp=*((short int*)&DINP[z-2]);
			if((datp<0)&&(dat>=0)){
				st=z;continue;
			}
			if(z>200)
				st=z;
			continue;
		}
		//count pulses
		dat=*((short int*)&DINP[z]);
		datp=*((short int*)&DINP[z-2]);
		if((datp<0)&&(dat>=0)){
			//CINP[z/2]=0xFFFFFF;
			ZERO[pos/2]=1;
			lastzeropos=pos;
		}
		//compress to buffer
		if(cnt<1){
			DOUT[pos++]=DINP[z];
			DOUT[pos++]=DINP[z+1];
			cnt++;
		}else{
			cnt=0;
		}
	}

	DOUT[lastzeropos++]=0;
	DOUT[lastzeropos++]=0;
	
	//double all output pulses
	pos=0;
	st=0;
	for(z=0;z<lastzeropos;z+=2){
		CONV[pos++]=DOUT[z];
		CONV[pos++]=DOUT[z+1];
		if(ZERO[z/2]){
			for(w=st;w<z;w++)
				CONV[pos++]=DOUT[w];
			st=w;
		}
	}
	
	//final alignment
	int needed=(BLOCK_SIZE-pos)/2;
	//int done=0;
	int space=BLOCK_SIZE/2/needed;
	pos=0;
	cnt=0;
	for(z=0;z<BLOCK_SIZE;z+=2){
		DOUT[pos++]=CONV[z];
		DOUT[pos++]=CONV[z+1];
		if(pos>=BLOCK_SIZE)break;
		if(cnt>=space){
			cnt=0;
			DOUT[pos++]=CONV[z];
			DOUT[pos++]=CONV[z+1];
			//done++;
			if(pos>=BLOCK_SIZE)break;
		}else
			cnt++;
	}

	DOUT[BLOCK_SIZE-1]=0;
	DOUT[BLOCK_SIZE-2]=0;
}

//*****************************************************************

void MainForm::DSP_PitchDown(){
	//Speech shift down
	//input from DINP output to DOUT	
	int st=-1;
	int pos;
	int dat,datp;
	int z,w;
	unsigned char skipping=0;
	int lastzeropos;
	int cnt=0;
	pos=0;
	
	//Stage1: skip all second pulses
	for(z=2;z<BLOCK_SIZE;z+=2){
		//serch start of wave: on rising edge
		if(st==-1){
			//CINP[z/2]=0x0000FF;
			dat=*((short int*)&DINP[z]);
			datp=*((short int*)&DINP[z-2]);
			if((datp<0)&&(dat>=0)){
				st=z;continue;
			}
			if(z>200)
				st=z;
			continue;
		}
		//copy
		if(!skipping){
			DOUT[pos++]=DINP[z];
			DOUT[pos++]=DINP[z+1];
		}
		//search rising edge
		cnt++;
		dat=*((short int*)&DINP[z]);
		datp=*((short int*)&DINP[z-2]);
		if(((datp<0)&&(dat>=0))||(cnt>=441)){
			cnt=0;
			//CINP[z/2]=0xFFFFFF;
			skipping=!skipping;
			lastzeropos=pos;
		}
	}
	
	DOUT[lastzeropos++]=0;
	DOUT[lastzeropos++]=0;
	
	//Stage2: double all sample
	pos=0;
	CONV[pos++]=DOUT[0];
	CONV[pos++]=DOUT[1];
	for(z=2;z<lastzeropos;z+=2){
		dat=*((short int*)&DOUT[z]);
		datp=*((short int*)&DOUT[z-2]);
		dat=(dat+datp)/2;
		*((short int*)&CONV[pos])=dat;
		pos+=2;
		if(pos>=BLOCK_SIZE)break;
		CONV[pos++]=DOUT[z];
		CONV[pos++]=DOUT[z+1];
		if(pos>=BLOCK_SIZE)break;
		if(BLOCK_SIZE-pos<=lastzeropos-z+2){
			z+=2;
			for(;pos<BLOCK_SIZE;pos++)
				CONV[pos]=DOUT[z++];
			break;
		}
	}
	
	//Stage3: final alignment
	int needed=(BLOCK_SIZE-pos)/2;
	int done=0;
	int space;
	cnt=1;
	if(needed>0){
		space=BLOCK_SIZE/2/needed;
		pos=0;
		for(z=0;z<BLOCK_SIZE;z+=2){
			DOUT[pos++]=CONV[z];
			DOUT[pos++]=CONV[z+1];
			if(pos>=BLOCK_SIZE)break;
			if(cnt>=space){
				cnt=1;
				DOUT[pos++]=CONV[z];
				DOUT[pos++]=CONV[z+1];
				done++;
				if(done>=needed)break;
				if(pos>=BLOCK_SIZE)break;
			}else
				cnt++;
		}
		for(;pos<BLOCK_SIZE;pos++){
			DOUT[pos]=CONV[z++];
		}
	}else{
		memcpy(DOUT,CONV,BLOCK_SIZE);
	}

	//done=done;
}

//*****************************************************************

void MainForm::DSP_AmMod(){
	//AM Vocoder
	//input from DINP output to DOUT
	
/*
	//TEST: SAVE TO FILE ONE SELECTED PULSE*******************
	int st=0;
	int pos;
	int dat,datp;
	int z,w;
	unsigned char skipping=0;
	int lastzeropos;
	int cnt=0;
	pos=0;
	FILE*f;
	f=fopen("Pulse.txt","wt");
	
	//Stage1: skip all second pulses
	for(z=2;z<BLOCK_SIZE;z+=2){
		//serch start of wave: on rising edge
		if(st<15){
			CINP[z/2]=0x0000FF;
			dat=*((short int*)&DINP[z]);
			datp=*((short int*)&DINP[z-2]);
			if((datp<0)&&(dat>=0)){
				st++;
			}
			continue;
		}
		//copy

		CINP[z/2]=0x00FFFF;
		DOUT[pos++]=DINP[z];
		DOUT[pos++]=DINP[z+1];
		dat=*((short int*)&DOUT[z]);
		fprintf(f,"%d,\n",dat);
			
		//search rising edge
		cnt++;
		dat=*((short int*)&DINP[z]);
		datp=*((short int*)&DINP[z-2]);
		if(((datp<0)&&(dat>=0))||(cnt>=441)){
			cnt=0;
			CINP[z/2]=0xFFFFFF;
			lastzeropos=pos;
			skipping++;
			if(skipping>6)
				break;
		}
	}
	
	fclose(f);
	return;
*/

	int z;
	int dat,datp,datn;
	//Rectifier
	for(z=0;z<BLOCK_SIZE;z+=2){
		dat=*((short int*)&DINP[z]);
		*((short int*)&DINP[z])=(dat>=0)?dat:-dat;
	}

	//Create coverer wave
	DOUT[0]=0;
	DOUT[1]=0;
	DOUT[BLOCK_SIZE-1]=0;
	DOUT[BLOCK_SIZE-2]=0;
	for(z=2;z<BLOCK_SIZE-2;z+=2){
		dat=*((short int*)&DINP[z]);
		datp=*((short int*)&DINP[z-2]);
		datn=*((short int*)&DINP[z+2]);
		if((dat>0)&&(dat>datn)&&(dat>datp)){
			DOUT[z]=DINP[z];
			DOUT[z+1]=DINP[z+1];
		}else{
			DOUT[z]=0;
			DOUT[z+1]=0;
		}
	}
	
	int lastpul=0;
	float b,m;
	int w;
	for(z=0;z<BLOCK_SIZE;z+=2){
		if(DOUT[z]){
			datp=*((short int*)&DOUT[z]);
			datn=*((short int*)&DOUT[lastpul]);
			Line(z,datp,lastpul,datn,DOUT);
			lastpul=z;
		}
	}
	
//wave1
	int count=0;
	float perc;
	for(z=0;z<BLOCK_SIZE;z+=2){
		perc=(float)(*((short int*)&DOUT[z])/20000.0);
		*((short int*)&DOUT[z])=(int)(perc*(float)waveD[count])/2+*((short int*)&DINP[z])/2;
		count++;
		if(count>=WLEN)count=0;
	}
	
}

void MainForm::Line(int x1, int y1, int x2, int y2, unsigned char* DAT){
	int dx, dy, inx, iny, e;
	
	dx = x2 - x1;
	dy = y2 - y1;
	inx = dx > 0 ? 1 : -1;
	iny = dy > 0 ? 1 : -1;

	dx = (dx>=0)?dx:-dx;
	dy = (dy>=0)?dy:-dy;
	
	if(dx >= dy) {
		dy <<= 1;
		e = dy - dx;
		dx <<= 1;
		while (x1 != x2) {
			//setpixel(x1, y1, color);
			*((short int*)&DAT[x1])=y1;
			if(e >= 0) {
				y1 += iny;
				e-= dx;
			}
			e += dy; x1 += inx;
		}
	} else {
		dx <<= 1;
		e = dx - dy;
		dy <<= 1;
		while (y1 != y2) {
			//setpixel(x1, y1, color);
			*((short int*)&DAT[x1])=y1;
			if(e >= 0) {
				x1 += inx;
				e -= dy;
			}
			e += dx; y1 += iny;
		}
	}
	//setpixel(x1, y1, color);
	*((short int*)&DAT[x1])=y1;
}
