//MainForm
#ifndef MainFormH
#define MainFormH

#include "..\FormClass.h"
#include "..\AnsiString.h"
#include "..\hinstance.h"
#include "..\AudioRecorder.h"
#include "..\AudioClass.h"
#include "..\ButtonClass.h"
#include "..\CanvasClass.h"
#include "..\TCheckBox.h"
#include "..\TRadioButton.h"
#include "..\LabelClass.h"

#include "MainFormParams.h"

static volatile int crec=0;
static volatile int InAudioLoop=0;

class MainForm : FormClass{
public:
	MainForm();
	~MainForm();
	void BuildForm(HWND hwnd,HINSTANCE hInst);
	void DestroyForm();
	void OnPaint();
	void OnCommand(WORD command);
	void OnAudioRecData();
	
	Button*  Button01;
	Button*  Button02;
	Label* Label1;
	
	TCheckBox*Check1;
	TRadioButton*Radio1;
	TRadioButton*Radio2;
	TRadioButton*Radio3;
	TRadioButton*Radio4;
	TCheckBox*Check2;
	TRadioButton*Radio5;
	TRadioButton*Radio6;
	TCheckBox*Check3;
	TRadioButton*Radio7;
	TRadioButton*Radio8;
	TRadioButton*Radio9;
	TRadioButton*Radi10;
	
	CanvasClass* Canvas;
	
	void Button1Click();
	void Button2Click();
	
	void Check1Click();
	void Check2Click();
	void Check3Click();
	void Radio1Click();
	void Radio2Click();
	void Radio3Click();
	void Radio4Click();
	void Radio5Click();
	void Radio6Click();
	void Radio7Click();
	void Radio8Click();
	void Radio9Click();
	void Radio10Click();

private:	// User declarations
	AudioRecorder* REC;
	AudioClass* AUDIOOUT;
	
	//input output data buffers
	unsigned char* DINPorig;
	unsigned char* DINP;
	unsigned char* DOUT;
	unsigned char* CONV;
	unsigned char* ZERO;
	unsigned char* DPLAY;
	
	//Screen buffers
	unsigned char Screen[650];
	unsigned char Screen2[650];
	
	//for echo generator
	unsigned char* echo;
	long int Pecho;

	//Mode variables
	char recordingRUN;
	char AMmodOn;
	char PitchOn;
	char EchoOn;
	char AMmod;
	char PitchMod;
	char EchoMod;
	
	//AM modulation
	int WLEN;
	int* waveD;
	
	//SIGNAL PROCESSOR FUNCTIONS
	void DSP_PitchUP();
	void DSP_PitchDown();
	void DSP_AmMod();
	void Line(int x1, int y1, int x2, int y2, unsigned char* DAT);
	
	//Save to file
	FILE*fwave;
	int BlocksSaved; 
};

#endif
